function d=determinante(A)
% calcola il determinante della matrice A

[n,m]=size(A);
if n~=m
    error('la matrice A non e quadrata');
end

if n==1
    d=A;
else
    d=0;
    segno=1;
    for i=1:n
        d=d+segno*A(i,1)*determinante(A([1:i-1 , i+1:n], 2:n));
        segno=-segno;
    end
end