%[x] = utri_sys2(A, b)
%restituisce il vettore colonna delle soluzioni del sistema lineare
%individuato dalla matrice triangolare superiore A e dal vettore colonna dei coefficienti b
%implementazione per righe
function [x] = utri_sys2(A, b)

n = issquare(A);

if(n == 0)
     error('La matrice A deve essere una matrice quadrata!')
end

if(n ~= length(b))
     error('Le dimensioni del vettore b e della matrice A non corrispondono')
end

x = b;
for i = n:-1:1
    for j = i+1:n
        x(i)=x(i)-A(i,j)*x(j);
    end
    x(i)=x(i)/A(i,i);
end
return