function p = SteepestDescent(p)

x=getStart(p); %Prendo il punto iniziale

gx=getGrad(p,x);% calcolo il gradiente nel punto

tol=getTol(p);

maxiter=getMaxiter(p);
n=0;
fx1=0;
fx2=0;
fx3=0;

% faccio almeno 2 iterazioni per poter stimare il minimo
% con il metodo di delta^2-Aitken

while n<3 || (abs(fx3-(fx1*fx3-fx2*fx2)/(fx3+fx1-2*fx2)) > tol && n < maxiter)
    fx3=fx2;
    fx2=fx1;
    
    % minimizzo la funzione x0+a g(x)
    res=armijo(p,x,-gx,gx);
    x=res{1};
    fx1=res{2};
    nextPoint(p,x);
    n=n+1;
    gx=getGrad(p,x); %riaggiorno il gradiente
end