% [g] = gev (v, k)
% Computa il vettore elementare di Gauss del vettore colonna v
% rispetto al k-esimo elemento del vettore stesso
function g = gev (v, k)
n = lenght(v)
if k < 1 | k > n
     error('non esiste il k-esimo elemento del vettore v')
end

g = [zeros(k,1) ; v(k+1:n)]/v(k);
return
