function p = FMinGrad(p)

x0=getStart(p);
maxiter=getMaxiter(p);
n=0;

option=optimset('OutputFcn',@outfun,'GradObj','on', ...
                'TolFun',getTol(p),'LargeScale','off');

fminunc(@objfun,x0,option);

function [f,g] = objfun(x)
    f = getValue(p,x);
    if nargout > 1
        g = getGrad(p,x);
    end
end

function stop = outfun(x, optimValues, state)
    n=n+1;
    nextPoint(p,x);
    if n < maxiter
        stop = false;
    else
        stop = true;
    end
    
end

end