function p = Newton(p)

tol=getTol(p);
tol2=tol^2;
maxiter=getMaxiter(p);

x=getStart(p); %Prendo il punto iniziale
gx=getGrad(p,x);% calcolo il gradiente nel punto
hx=getHess(p,x);

[d,A]=ldlt_fact_sys(hx,-gx);
n=0;

while n<maxiter && gx'*gx>tol2
    if(all(d==0))
        warning('La matrice non era SDP!!! mi fermo');
        return;
    end
    x=x+d;
    nextPoint(p,x);
    n=n+1;
    gx=getGrad(p,x); %riaggiorno il gradiente
    hx=getHess(p,x);
    d=ldlt_fact_sys(hx,-gx);
end